package com.hzs.common.core.enums;

import com.hzs.common.core.constant.EnumsPrefixConstants;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 审批业务类型
 */
@AllArgsConstructor
@Getter
public enum EApprovalBusiness {

    /**
     * 自定义签呈
     */
    CUSTOM(0, "自定义签呈", EnumsPrefixConstants.APPROVAL_BUSINESS + "0"),

    /**
     * 修改姓名
     */
    CHANGE_NAME(100, "变更会员姓名", EnumsPrefixConstants.APPROVAL_BUSINESS + "100"),
    /**
     * 修改手机号
     */
    CHANGE_PHONE(101, "变更联系方式", EnumsPrefixConstants.APPROVAL_BUSINESS + "101"),

    /**
     * 实名认证
     */
    REAL_NAME_AUTHENTICATION(102, "实名认证", EnumsPrefixConstants.APPROVAL_BUSINESS + "102"),

    /**
     * 重置会员密码
     */
    RESET_LOGIN_PASSWORD(103, "重置会员密码", EnumsPrefixConstants.APPROVAL_BUSINESS + "103"),

    /**
     * 修改注册等级
     */
    CHANGE_REGISTER_GRADE(106, "修改注册等级", EnumsPrefixConstants.APPROVAL_BUSINESS + "106"),
    /**
     * 修改奖衔
     */
    CHANGE_AWARDS(107, "修改真实奖衔", EnumsPrefixConstants.APPROVAL_BUSINESS + "107"),
    /**
     * 修改会员礼包收货地址
     */
    CU_MEMBER_GIFT(108, "修改会员礼包收货地址", EnumsPrefixConstants.APPROVAL_BUSINESS + "108"),
    /**
     * 修改编号
     */
    CHANGE_MEMBER_CODE(109, "修改编号", EnumsPrefixConstants.APPROVAL_BUSINESS + "109"),

    /**
     * 修改安置
     */
    CU_MEMBER_PLACE_PARENT(110, "修改安置关系", EnumsPrefixConstants.APPROVAL_BUSINESS + "110"),

    /**
     * 修改直推
     */
    CU_MEMBER_PARENT(111, "修改直推", EnumsPrefixConstants.APPROVAL_BUSINESS + "111"),
    /**
     * 重置银行
     */
    RESET_BANK(112, "重置银行信息", EnumsPrefixConstants.APPROVAL_BUSINESS + "112"),
    /**
     * 修改结算等级
     */
    CHANGE_SETTLEMENT_GRADE(113, "修改结算等级", EnumsPrefixConstants.APPROVAL_BUSINESS + "113"),
    /**
     * 修改自然国
     */
    CHANGE_NATURAL_COUNTRY(115, "修改自然国家", EnumsPrefixConstants.APPROVAL_BUSINESS + "115"),
    /**
     * 修改登录状态
     */
    SIGN_IN_STATE(116, "修改登录状态", EnumsPrefixConstants.APPROVAL_BUSINESS + "116"),
    /**
     * 收益状态
     */
    PROFIT_STATE(117, "修改收益状态", EnumsPrefixConstants.APPROVAL_BUSINESS + "117"),
    /**
     * 钱包状态
     */
    WALLET_STATE(118, "修改钱包状态", EnumsPrefixConstants.APPROVAL_BUSINESS + "118"),
    /**
     * 免考状态
     */
    FREE_ASSESSMENT_STATE(119, "修改免考状态", EnumsPrefixConstants.APPROVAL_BUSINESS + "119"),
    /**
     * 注册权限状态
     */
    REGISTER_POWER_STATE(120, "修改注册权限", EnumsPrefixConstants.APPROVAL_BUSINESS + "120"),

    /**
     * 注水业绩
     */
    MEMBER_ACHIEVE(123, "注水业绩", EnumsPrefixConstants.APPROVAL_BUSINESS + "123"),
    /**
     * 特殊业务-修改结算国
     */
    UPDATE_SETTLE_COUNTRY(124, "修改结算国", EnumsPrefixConstants.APPROVAL_BUSINESS + "124"),
    /**
     * 办理政策币
     */
    POLICY_CURRENCY_YES_NO(125, "办理政策币", EnumsPrefixConstants.APPROVAL_BUSINESS + "125"),
    /**
     * 删除办理政策币
     */
    DEL_POLICY_CURRENCY_YES_NO(126, "删除办理政策币", EnumsPrefixConstants.APPROVAL_BUSINESS + "126"),
    /**
     * 自助服务-修改收货地址
     */
    SELF_MODIFY_ADDRESS(131, "自助服务修改收货地址", EnumsPrefixConstants.APPROVAL_BUSINESS + "131"),

    /**
     * 自助服务-户籍变更
     */
    DOMICILE_CHANGE(132, "户籍变更", EnumsPrefixConstants.APPROVAL_BUSINESS + "132"),

    /**
     * 营业执照
     */
    BUSINESS_LICENSE(133, "营业执照", EnumsPrefixConstants.APPROVAL_BUSINESS + "133"),
    /**
     * 零元撤单
     */
    ZERO_ELEMENT_REVOKE(134, "零元撤单", EnumsPrefixConstants.APPROVAL_BUSINESS + "134"),
    /**
     * 重置营业执照
     */
    BUSINESS_LICENSE_RESETTING(135, "重置营业执照", EnumsPrefixConstants.APPROVAL_BUSINESS + "135"),
    /**
     * 是否收益区域
     */
    IS_REGION(136, "是否收益区域", EnumsPrefixConstants.APPROVAL_BUSINESS + "136"),

    /**
     * 是否激活
     */
    IS_ACTIVATE(137, "是否激活", EnumsPrefixConstants.APPROVAL_BUSINESS + "137"),

    /**
     * 修改历史最高奖衔
     */
    CHANGE_MAX_AWARDS(166, "修改历史最高奖衔", EnumsPrefixConstants.APPROVAL_BUSINESS + "166"),

    /**
     * 空单注册
     */
    EMPTY_ORDER(190, "空单注册", EnumsPrefixConstants.APPROVAL_BUSINESS + "190"),

    /**
     * 订单修改地址
     */
    ORDER_CHANGE_ADDRESS(231, "修改地址", EnumsPrefixConstants.APPROVAL_BUSINESS + "231"),
    /**
     * 订单调换货物
     */
    ORDER_CHANGE_PRODUCT(232, "调换货物", EnumsPrefixConstants.APPROVAL_BUSINESS + "232"),
    /**
     * 订单退单
     */
    ORDER_RETURN(233, "退单", EnumsPrefixConstants.APPROVAL_BUSINESS + "233"),
    /**
     * 订单撤销订单
     */
    ORDER_CANCEL(234, "撤销订单", EnumsPrefixConstants.APPROVAL_BUSINESS + "234"),
    /**
     * 订单撤销产品
     */
    ORDER_CANCEL_PRODUCT(235, "撤销产品", EnumsPrefixConstants.APPROVAL_BUSINESS + "235"),

    /**
     * 订单自提
     */
    SELF_DELIVERY_MANAGE(251, "订单自提", EnumsPrefixConstants.APPROVAL_BUSINESS + "251"),

    /**
     * 订单抵扣
     */
    ORDER_DEDUCTION(254, "订单抵扣", EnumsPrefixConstants.APPROVAL_BUSINESS + "254"),

    /**
     * 财务充值
     */
    RECHARGE(300, "财务充值", EnumsPrefixConstants.APPROVAL_BUSINESS + "300"),
    /**
     * 财务提现
     */
    WITHDRAWAL(301, "财务提现", EnumsPrefixConstants.APPROVAL_BUSINESS + "301"),
    /**
     * 财务提现
     */
    FROZEN(309, "财务冻结", EnumsPrefixConstants.APPROVAL_BUSINESS + "309"),

    /**
     * 产品添加
     */
    PRODUCT_SAVE(400, "产品添加", EnumsPrefixConstants.APPROVAL_BUSINESS + "400"),

    /**
     * 产品修改
     */
    PRODUCT_UPDATE(401, "产品修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "401"),
    /**
     * 产品删除
     */
    PRODUCT_REMOVE(402, "产品删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "402"),
    /**
     * 产品上移
     */
    PRODUCT_MOVEUP(403, "产品上移", EnumsPrefixConstants.APPROVAL_BUSINESS + "403"),
    /**
     * 产品下移
     */
    PRODUCT_MOVEDOWN(404, "产品下移", EnumsPrefixConstants.APPROVAL_BUSINESS + "404"),

    /**
     * 商品添加
     */
    WARES_SAVE(405, "商品添加", EnumsPrefixConstants.APPROVAL_BUSINESS + "405"),
    /**
     * 商品修改
     */
    WARES_UPDATE(406, "商品修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "406"),

    /**
     * 商品删除
     */
    WARES_REMOVE(407, "商品删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "407"),

    /**
     * 商品上移
     */
    WARES_MOVEUP(408, "商品上移", EnumsPrefixConstants.APPROVAL_BUSINESS + "408"),

    /**
     * 商品下移
     */
    WARES_MOVEDOWN(409, "商品下移", EnumsPrefixConstants.APPROVAL_BUSINESS + "409"),

    /**
     * 商品置顶
     */
    WARES_TOP(410, "商品置顶", EnumsPrefixConstants.APPROVAL_BUSINESS + "410"),
    /**
     * 产品置顶
     */
    PRODUCT_TOP(411, "产品置顶", EnumsPrefixConstants.APPROVAL_BUSINESS + "411"),

    /**
     * 公告
     */
    MEMBER_NOTICE(520, "前台公告", EnumsPrefixConstants.APPROVAL_BUSINESS + "520"),

    ADMIN_NOTICE(521, "后台公告", EnumsPrefixConstants.APPROVAL_BUSINESS + "521"),

    /**
     * 站内信
     */
    MESSAGE_PLATFORM(522, "站内信", EnumsPrefixConstants.APPROVAL_BUSINESS + "522"),

    /**
     * 提货充值
     */
    PICK_ADD(700, "提货充值", EnumsPrefixConstants.APPROVAL_BUSINESS + "700"),
    /**
     * 删除提货充值
     */
    PICK_ADD_DEL(701, "提货充值删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "701"),

    /**
     * 抽奖配置增加
     */
    LOTTERY_DRAW_ADD(717, "抽奖配置增加", EnumsPrefixConstants.APPROVAL_BUSINESS + "717"),

    /**
     * 抽奖配置修改
     */
    LOTTERY_DRAW_UPDATE(718, "抽奖配置修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "718"),

    /**
     * 抽奖配置删除
     */
    LOTTERY_DRAW_REMOVE(719, "抽奖配置删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "719"),

    /**
     * 直推赠送
     */
    DIRECT_PUSH_GIFT(723, "直推赠送", EnumsPrefixConstants.APPROVAL_BUSINESS + "723"),

    /**
     * 抽奖
     */
    LOTTERY_DRAW(724, "抽奖", EnumsPrefixConstants.APPROVAL_BUSINESS + "724"),
    /**
     * 复购券
     */
    REPURCHASE_COUPON(720, "复购券", EnumsPrefixConstants.APPROVAL_BUSINESS + "720"),
    /**
     * 直推升级
     */
    DIRECT_PUSH_UPGRADE(721, "直推升级", EnumsPrefixConstants.APPROVAL_BUSINESS + "721"),

    /**
     * 复购均分
     */
    REPURCHASE_SHAR(722, "复购均分", EnumsPrefixConstants.APPROVAL_BUSINESS + "722"),

    /**
     * 商品赠送添加
     */
    PRODUCT_GIFT_ADD(729, "商品赠送添加", EnumsPrefixConstants.APPROVAL_BUSINESS + "729"),

    /**
     * 商品赠送修改
     */
    PRODUCT_GIFT_UPDATE(730, "商品赠送修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "730"),

    /**
     * 商品赠送删除
     */
    PRODUCT_GIFT_REMOVE(731, "商品赠送删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "731"),

    /**
     * 消费赠送添加
     */
    CONSUME_GIFT_ADD(738, "消费赠送添加", EnumsPrefixConstants.APPROVAL_BUSINESS + "738"),

    /**
     * 消费赠送修改
     */
    CONSUME_GIFT_UPDATE(739, "消费赠送修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "739"),

    /**
     * 消费赠送删除
     */
    CONSUME_GIFT_REMOVE(740, "消费赠送删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "740"),
    /**
     * 充值已购买次数
     */
    PUR_CHASED_TIMES(744, "充值已购买次数", EnumsPrefixConstants.APPROVAL_BUSINESS + "744"),

    /**
     * 充值未购买次数
     */
    UN_PUR_CHASED_TIMES(745, "充值未购买次数", EnumsPrefixConstants.APPROVAL_BUSINESS + "745"),

    /**
     * 会员消费赠送添加
     */
    MEMBER_CONSUME_GIFT_ADD(749, "会员消费赠送添加", EnumsPrefixConstants.APPROVAL_BUSINESS + "749"),

    /**
     * 会员消费赠送修改
     */
    MEMBER_CONSUME_GIFT_UPDATE(750, "会员消费赠送修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "750"),

    /**
     * 会员消费赠送删除
     */
    MEMBER_CONSUME_GIFT_REMOVE(751, "会员消费赠送删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "751"),

    /**
     * 提货赠送活动添加
     */
    RETAIL_PICK_PRODUCT_ADD(752, "提货赠送活动添加", EnumsPrefixConstants.APPROVAL_BUSINESS + "752"),

    /**
     * 提货赠送活动修改
     */
    RETAIL_PICK_PRODUCT_UPDATE(753, "提货赠送活动修改", EnumsPrefixConstants.APPROVAL_BUSINESS + "753"),

    /**
     * 提货赠送活动删除
     */
    RETAIL_PICK_PRODUCT_REMOVE(754, "提货赠送活动删除", EnumsPrefixConstants.APPROVAL_BUSINESS + "754"),

    ;

    /**
     * 实际值
     */
    private final int value;
    /**
     * 显示标签
     */
    private final String label;
    /**
     * 国际化翻译KEY值
     */
    private final String key;

    /**
     * 根据枚举值获取枚举
     *
     * @param value 枚举值
     * @return
     */
    public static EApprovalBusiness getEnumByValue(int value) {
        for (EApprovalBusiness eApprovalBusiness : EApprovalBusiness.values()) {
            if (eApprovalBusiness.getValue() == value) {
                return eApprovalBusiness;
            }
        }
        return null;
    }

}
